/** 
DrawingBoard.java 

Author: Laura Toma based on Eric Chown

Description: when created, it draws an empty window. Sussessive calles
to BigDot(row, col) draws a big dot at the specified row and column,
and connects it with a line to the previous dot.
 */


import javax.swing.*;
import java.awt.*;


public class DrawingBoard extends JFrame {
    
    static final int GRIDSIZE = 40;     // size of one square
    static final int GRIDOFFSET = 51;   // for centering drawing
    static final int DOTRADIUS = 20;    // size of the dots
    protected int PointX = 0;           // holds last x value
    protected int PointY = 0;           // holds last y value
    protected boolean first = true;     // is this the first dot?
    

    /** Constructor - create the window and show it    
     */
    public DrawingBoard(int x,  int y) {
	super("Dot Patterns");
	setSize(400, 400);
	setLocation(x, y);
	setVisible(true);
    }

    /** change the title of the board to <s>
     */
    public void changeTitle(String s) {
	setTitle(s);
    }

    /**  Scale the size of the dot according to the window size    
     */
    public int scale (int z) {
	return (z * GRIDSIZE + GRIDOFFSET);
    }

    
    /** Whiteout the screen
     */   
    public void clear()  {
	first = true;
	Graphics g = this.getGraphics();
	int Width = getSize().width;
	int Height = getSize().height;
	g.setColor(Color.white);
	g.fillRect(0, 0, Width, Height);
    }



    /** Main drawing routine.  Draws a new dot at row, col and
	connects it to the previous Dot (if it exists).    
    */
    public void bigDot(int col, int row)  {
	//  Goofy java nescessity to make sure we draw in the right place
	Graphics g = this.getGraphics();
	
	// draw big dot at row, col position
	g.setColor(Color.blue);    // changes the color to blue
	g.fillOval(scale(row) - DOTRADIUS/2, scale(col) - DOTRADIUS/2, 
		   DOTRADIUS, DOTRADIUS);
	
	// if first dot then simply reset first to false
	// otherwise draw line from last dot to this dot
	if (first)
	    first = false;
	else
	    g.drawLine(scale(PointX), scale(PointY), scale(row), scale(col));
	
	// now reset last dot for next call to BigDot
	PointX = row;
	PointY = col;
    } 


} //end of class DrawingBoard